**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              tresorerie_donnees
Sequence         2 - Le modle d'exploitation agricole
Type             LP
Langage GAMS     incrmenter un SET dans une variable
Description
Ajout du calcul de la marge brute
"Un agriculteur a la possibilit de cultiver du bl, de la betterave et de l'orge.
Il dispose de 100 ha et doit dterminer la superficie pour chaque culture
sachant qu'il veut maximiser son revenu.
Les charges fixes de sa structure sont de 30500 rparties mensuellement.
Sa trsorerie initiale est de 30500. Tous les mois il prlve 1200 pour son salaire personnel.
Ses charges mensuelles par cultures (dpenses en produits phytosanitaires,
 couts en matriel, carburant et entretien, et engrais) sont :
Charges mensuelles par culture ()
Mois     m1   m2   m3   m4   m5   m6   m7   m8   m9  m10  m11  m12
ble       0   10  130   90   10   10    0   210   0  110    0    0
bett      0    0   10  330   30   10   10    0  110  370   10   15
orge      0   10  130   90   10   10    0   200   0  110    0    0
Le bl et l'orge sont vendus le mois suivant la rcolte (M8), au mois de septembre (M9)
 un prix respectif de 17/q et 14/q. La betterave est sous contrat et le solde est pay au mois de dcembre  38/t.
Les rendements pour le bl, la betterave et l'orge sont respectivement de 70q/ha, 50q/h et 72t/ha.
L'agriculteur peut emprunter  la banque de l'argent mensuellement  un taux d'intrt annuel 0.12."



$Offtext
*-----------------------------------------------------------------------------*


sets
cult
/ble,bett,orge/
m mois
/m1*m12/
;
scalars

FIX   charges de structure           /30500/
IECT  tx interet  emprunts CT        /0.12/
sau   surface agricole en hectares      /100/
;

Parameter TRESOi(m) tresorerie initiale
/m1 20000/;

Parameter PRELEV(m) prelevement familial
/m1*m12  2000/
;

table charges(cult,m) charges totales (depense en produits phyto cout en materiel carburant entretien et engrais par mois en )
         m1   m2   m3   m4   m5   m6   m7   m8   m9  m10  m11  m12
ble       0   10  130   90   10   10    0   210   0  110    0    0
bett      0    0   10  330   30   10   10    0  110  370   10   15
orge      0   10  130   90   10   10    0   200   0  110    0    0
;


parameter rdt(cult)      rendement
/ble 70,bett 50,orge 72/
;

table pxc(cult,m) prix de vente des cultures
          m9    m12
ble       17
bett            31
orge      14
;


variables
revenu
marge   marge brute globale
fraisfi frais financiers

empt(m)  montant de l'emprunt mensuel
cash(m)  tresorerie disponible par mois
x(cult)  surface  par culture

;
positive variable
x,cash,empt
;
equations
eqsau     contrainte de terre
eqmarge  calcul de la marge annuelle globale

eqcash(m) contrainte de tresorerie mensuelle
eqfraisfi   calcul des frais financiers
eqrev     calcul du revenu
;
eqsau .. sum(cult,x(cult))=l=sau;

eqmarge .. sum((cult,m),x(cult)*rdt(cult)*pxc(cult,m))
            - sum((cult,m),x(cult)*charges(cult,m)) =e= marge;

eqcash(m) .. tresoi(m)+ sum(cult,x(cult)*rdt(cult)*pxc(cult,m))+cash(m-1)+empt(m)=e=
             sum(cult,x(cult)*charges(cult, m))
             +fix/12
             +prelev(m)
             + empt(m)*iect/12
             + empt(m-1)
             +cash(m);

eqfraisfi .. fraisfi =e= sum(m,empt(m))*iect/12;

eqrev .. revenu =e= marge -fix- fraisfi ;

model modeleTreso /ALL/

SOLVE modeleTreso USING lp MAXIMIZING revenu;


